/*
 
 Function for Software-SPI
 Sends a Byte to a 74HC595 connected to port B
 
 void spi(unsigned char);
 
 */
 #define __SFR_OFFSET 0
 
 #include <avr/io.h>
 
 
 /*
 Which pins should be used for the SPI connection?
 */
 
 #define MOSI	PB0
 #define SCK	2
 
 #define value r24 /* rP1 */
 #define count r31 /* rTI0 */
 
    .stabs	"",100,0,0,spi             /* needed for AVRStudio 4.08 debugging */
    .stabs	"spi.S",100,0,0,spi        /* needed for AVRStudio 4.07 debugging */
    .global spi
    .func spi
 
 spi:                    //  that's the beginning of the function
    clr count
    
 loop:
    cbi PORTB, MOSI
    rol value
    brcc carrycleared
    sbi PORTB, MOSI
 carrycleared:
    nop
    sbi PORTB, SCK
    nop
    cbi PORTB, SCK
    inc count
    cpi count, 8
    brne loop
 
    ret                   // end of function, return to main program
 
    .endfunc
 
